  
# Dapr 1.4.1

## Fixes

* Sidecar-injector.dapr.io admission webhook deny access to Kubernetes nodes (https://github.com/dapr/dapr/issues/3699)
* PubSub routing fails when using event more than once (https://github.com/dapr/dapr/issues/3693)

### Overview

#### Issue #3699

When trying to connect to an Kubernetes node, using the `kubectl debug` command (for example, `kubectl debug node/ -it --image=mcr.microsoft.com/aks/fundamental/base-ubuntu:v0.0.11`), the connection is denied due "sidecar-injector.dapr.io" admission webhook:

```txt
Error from server: admission webhook "sidecar-injector.dapr.io" denied the request: service account 'xxxxxxx' not on the list of allowed controller accounts
```
#### Issue #3693

The following CEL expression for PubSub Routing fails:

`has(event.data.important) && event.data.important == true`

Using event more than once causes an error because it tries to compile an underlying CEL program with the variable defined multiple times.